(function (exports) {
    // if (TG_Rules("niceScroll")) {
    // 	var ns = {
    // 		autohidemode: true,
    // 		cursorwidth: "10px",
    // 		cursorcolor: "#7F7F7F"
    // 	};
    // 	$.extend(ns, window.parent.TG_CONFIG.niceScroll)
    // 	$("body").niceScroll(ns);
    // }

    exports.defaults.displayFieldFormat = "_DISPLAY";
    exports.defaults.antd.form.select.default.async = true;
    exports.defaults.antd.form["multi-select2"] = exports.defaults.antd.form["multi-select"];

    exports.axios.defaults.timeout = 5000;
    exports.axios.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
    exports.axios.defaults.transformRequest = [function (data) {
        if (data instanceof FormData) {
            return data;
        } else {
            var ret = []
            for (var it in data) {
                ret.push(encodeURIComponent(it) + '=' + encodeURIComponent(data[it]))
            }
            return ret.join('&');
        }
    }]
    exports.defaults.beforeFindAll[0] = function(action, params, props) {
        return exports.utils.extend({}, params.where, {
            pageSize: props.pageSize,
            pageNumber: props.pageNumber
        })
    }
    exports.defaults.afterFindAll[0] = function(data, action){
        if (data.data instanceof Array === true) {
            return data.data;
        } else {
            if (data.data.datas === undefined || data.data.datas[action.name] === undefined) {
                console.error("请求返回数据异常", action.url, action, data);
            }
            data.data.datas[action.name].count = data.data.datas[action.name].totalSize;
            data.data.datas[action.name].index = data.data.datas[action.name].pageNumber;
            data.data.datas[action.name].size = data.data.datas[action.name].pageSize;
            return data.data.datas[action.name];
        }
    }

    exports.defaults.getDictData[0] = function (dict, params, callback){
        var newParams = {};
        if (params.key !== undefined) {
            newParams = {"searchValue": params.key};
        }
        exports.utils.Post(dict.url, newParams).then(function(result) {
            var datas;
            if (result.data instanceof Array === true) {
                datas = result.data.map(function(item) {
                    return {
                        label: item["name"],
                        value: item["id"]
                    }
                })
                callback(datas);
            } else {
                try{
                    datas = result.data.datas.code.rows.map(function(item) {
                        return {
                            label: item["name"],
                            value: item["id"]
                        }
                    })
                    callback(datas);
                } catch (e) {
                    console.error(e, dict.url, dict, result);
                }
            }
        })
    };
    exports.defaults.getDictTreeData[0] = function (dict, params, callback){
        var treeParams = {};
        if (params !== undefined && params.key !== undefined) {
            treeParams = {"pId": params.key};
        }
        exports.utils.Post(dict.url, treeParams).then(function(result) {
            var datas;
            try{
                datas = result.data.datas.code.rows.map(function(item) {
                    item["label"] = item["name"];
                    item["value"] = item["id"];
                    if (item["isParent"] === 1) {
                        item["children"] = [];
                        item["loading"] = false;
                    }
                    return item;
                })
                if (params !== undefined && params.key !== undefined) {
                }else {
                    datas = window["tg-turing"].utils.toTreeData(datas, "", {ukey:"id", pkey:'pId', toCKey:'children'})
                }
                callback(datas);
            } catch (e) {
                console.error(e, dict.url, dict, result);
            }
        })
    };
    exports.defaults.getDictTreeDataAsync[0] = function (dict, params, callback){
        exports.utils.Post(dict.url, {"id": params.key,"checkParent": true}).then(function(result) {
            var datas;
            try{
                datas = result.data.datas.code.rows.map(function(item) {
                    item["label"] = item["name"];
                    item["value"] = item["id"];
                    return item;
                })
                datas = window["tg-turing"].utils.toTreeData(datas, "", {ukey:"id", pkey:'pId', toCKey:'children'})
                callback(datas);
            } catch (e) {
                console.error(e, dict.url, dict, result);
            }
        })
    };

    exports.DataAdapterFactory = {
        create: function () {
            if (arguments.length === 0) {
                return new exports.EMAPDataAdapter(exports.defaults.antd.Adapter);
            } else {
                var ds = new exports.EMAPDataAdapter(exports.defaults.antd.Adapter);
                ds.refresh(arguments[0], arguments[1], arguments[2]);
                ds.name = arguments[1];
                if (ds.viewDefine === undefined) {
                    throw "不存在模型：" + arguments[1] + "，请检查"
                }
                return ds;
            }
        }
    }

    exports.EMAP = {
        serialize: function(formData, model) {
            var cloneData = JSON.parse(JSON.stringify(formData));
            for (var prop in cloneData) {
                if (model[prop] !== undefined && model[prop].xtype !== undefined) {
                    switch (model[prop].xtype) {
                        case "checkboxlist":
                        case "date-range":
                        case "multi-select":
                            if (cloneData[prop] instanceof Array) {
                                cloneData[prop] = cloneData[prop].join(",");
                            } else {
                                cloneData[prop] = "";
                            }
                            break;
                        default:
                            break;
                    }
                }
            }
            return cloneData;
        },
        deserialize: function (formData, model) {
            var cloneData = JSON.parse(JSON.stringify(formData));
            for (var prop in cloneData) {
                if (model[prop] !== undefined && model[prop].xtype !== undefined) {
                    switch (model[prop].xtype) {
                        case "checkboxlist":
                        case "date-range":
                        case "multi-select":
                            cloneData[prop] = cloneData[prop].split(",");
                            break;
                        default:
                            break;
                    }
                }
            }
            return cloneData;
        }
    }
})(window["tg-turing"])